/*
								+---------------------------------+
								|                                 |
								|  ***   Lightmap computer   ***  |
								|                                 |
								|  Copyright   -tHE SWINe- 2003  |
								|                                 |
								|             Light.h             |
								|                                 |
								+---------------------------------+
*/

#ifndef __LIGHT_INCLUDED
#define __LIGHT_INCLUDED

enum {
	Plane_yz = 0,
	Plane_xz,
	Plane_xy
};

struct Group {
	int n_id;
	//
	int n_plane;
	Vector v_u, v_v;
	//
	Vector v_min, v_max;
	//
    int n_face_num;
    int n_face_used;
	//
    Face **p_face;
};
// group - facy, lec ve stejn
// rovin a navzjem si sousedc

struct Group_Data {
    Group *p_group;
    int n_group_num;
};

Group_Data *Group_Faces(World *p_world, float f_max_size);

struct Mapping_Info {
	Vector v_org;
	Vector v_u, v_v;
	//
	float f_width;
	float f_height;
	//
	int n_plane;
};
// informace o tom, kde kter lightmapa le

Mapping_Info *Generate_Map_Coords(Group_Data *p_group_data);



struct TLightmapTex {
	int n_width, n_height;
	//
	int *p_frontline;
	//
	unsigned __int32 *p_bytes;
};
// informace o vlastnch texturch

TLightmapTex *p_Lightmap(int n_width, int n_height);
int b_InsertTile(int n_width, int n_height, TLightmapTex *p_lightmap,
				 int *p_x, int *p_y, Matrix *p_coord_transform);


void Raytrace_Tile(Group *p_group, Mapping_Info *p_mapping_info, World *p_world,
				   int n_x, int n_y, int n_h, int n_w, int n_p_w,
				   unsigned __int32 *p_buffer, unsigned __int32 n_ambient);

struct TBmp {
	int n_width, n_height;
	unsigned __int32 *p_bytes;
};

#endif // __LIGHT_INCLUDED